<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "scan_competitor_practice".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ScanCompetitorPractice".
 *
 * Columns in table "scan_competitor_practice" available as properties of the model,
 * followed by relations of table "scan_competitor_practice" available as properties of the model.
 *
 * @property integer $id
 * @property integer $status_id
 * @property integer $reputation_status_id
 * @property string $name
 * @property string $place_id
 * @property string $address
 * @property string $zipcode
 * @property string $search_result
 * @property string $date_added
 * @property integer $score
 *
 * @property ScanCompetitorPracticeBatch[] $scanCompetitorPracticeBatches
 * @property ScanCompetitorProvider[] $scanCompetitorProviders
 * @property Status $status
 * @property Status $reputationStatus
 */
abstract class BaseScanCompetitorPractice extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'scan_competitor_practice';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ScanCompetitorPractice|ScanCompetitorPractices', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('name, address, zipcode', 'length', 'max'=>150),
            array('place_id, score', 'length', 'max'=>150),
            array('search_result, date_added', 'safe'),
            array('status_id, reputation_status_id', 'length', 'max'=>10),
            array('name, place_id, address, zipcode, search_result, date_added', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, name, place_id, address, zipcode, search_result, date_added', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'scanCompetitorPracticeBatches' => array(self::HAS_MANY, 'ScanCompetitorPracticeBatch', 'scan_competitor_practice_id'),
            'scanCompetitorProviders' => array(self::HAS_MANY, 'ScanCompetitorProvider', 'scan_competitor_practice_id'),
            'status' => array(self::BELONGS_TO, 'Status', 'status_id'),
            'reputationStatus' => array(self::BELONGS_TO, 'Status', 'reputation_status_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'place_id' => Yii::t('app', 'Place'),
            'address' => Yii::t('app', 'Address'),
            'zipcode' => Yii::t('app', 'Zipcode'),
            'search_result' => Yii::t('app', 'Search Result'),
            'date_added' => Yii::t('app', 'Date Added'),
            'score' => Yii::t('app', 'Score'),
            'scanCompetitorPracticeBatches' => null,
            'scanCompetitorProviders' => null,
            'status_id' => null,
            'reputation_status_id' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('place_id', $this->place_id, true);
        $criteria->compare('address', $this->address, true);
        $criteria->compare('zipcode', $this->zipcode, true);
        $criteria->compare('search_result', $this->search_result, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('score', $this->score, true);
        $criteria->compare('status_id', $this->status_id);
        $criteria->compare('reputation_status_id', $this->reputation_status_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
